
BlendState noblend {
	AlphaToCoverageEnable = FALSE;
	BlendEnable[0] = FALSE;
};

cbuffer Constants {
};

cbuffer InstanceData {
	float4x4 v;
	float4x4 wv;
	float4x4 wvp;
	float4x4 p;
};


struct VS_OUTPUT {
    float4 Position : SV_POSITION;
	float3 Normal : NORMAL;
	//float4 tangent : TANGNENT;
	//float2 uv : TEXCOORD0;
};

SamplerState linearSampler {
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Wrap;
    AddressV = Wrap;
};

VS_OUTPUT VS(
		uint id : SV_InstanceID
		,float4 vPos : POSITION
		,float4 vNormal : NORMAL
		//,float4 vTangent: TANGENT 
		) 
{
    VS_OUTPUT Out;

	float pi = 3.1415926535897932384626433832795f;
	float t = asin(vPos.y) + pi * 0.5f;
	float i = pi * sqrt( vPos.x*vPos.x + vPos.z*vPos.z);
	float g = t/i;
	float4 pos;
	pos.x = vPos.x*g;
	pos.y = vPos.y*g;
	pos.z = 1;
	pos.w = 1;
	Out.Position = mul( pos, p );

	float3 normal = vNormal.xyz;
	Out.Normal = mul( float4(normal.xyz,0), wv ).xyz;
    return Out;
}

float4 PS( VS_OUTPUT In ) : SV_Target {
	float n = 1.0f / In.Position.z;
	return float4( n,0,0,0 );
}

technique10 Dual {
    pass P0 {
		SetBlendState( noblend, float4(1,1,1,1), 0xffffffff );
        SetVertexShader( CompileShader( vs_4_0, VS() ) );
        SetGeometryShader( NULL );
        SetPixelShader( CompileShader( ps_4_0, PS() ) );
    }
}
